#include "stdafx.h"

#include "DefineData.h"

void PID2IMG(DWORD processId)
{
}

bool ClipBoard2IMG(CString filename, HWND DsthWnd, CString *err_msg)
{
	static int nCount = 0;
	HBITMAP hBit;
	int capture_delay = 10;

	if(!IsClipboardFormatAvailable(CF_BITMAP))
	{
		*err_msg = _T("Ŭ  ");
		return FALSE;
	}

	if(!OpenClipboard(DsthWnd))
	{
		*err_msg = _T("Ŭ  ");
		return FALSE;
	}

	hBit=(HBITMAP)GetClipboardData(CF_BITMAP);	

	BITMAP bitmap;                                  // Ʈ(DDB) ü
    GetObject(hBit, sizeof(BITMAP), &bitmap);    // Ʈ(DDB)  
  
    BITMAPINFOHEADER bmih;                          // Ʈ(DIB)   ü
    ZeroMemory(&bmih, sizeof(BITMAPINFOHEADER));
    bmih.biSize = sizeof(BITMAPINFOHEADER);
    bmih.biWidth = bitmap.bmWidth;
    bmih.biHeight = bitmap.bmHeight;
    bmih.biPlanes = 1;
    bmih.biBitCount = 24;       // 24Ʈ Ʈ÷
    bmih.biCompression = BI_RGB; 
 
    HDC hDC = GetDC(GetDesktopWindow());
 
    // Ʈ   
    //GetDIBits(hDC, hBit, 0, bitmap.bmHeight, NULL, (LPBITMAPINFO)&bmih, DIB_RGB_COLORS);
	GetDIBits(hDC, hBit, 0, bitmap.bmHeight, NULL, (LPBITMAPINFO)&bmih, DIB_RGB_COLORS); 
 
    // Ʈ ͸ ϱ   
    LPBYTE lpBits = new BYTE[bmih.biSizeImage]; 
 
    // Ʈ ͸ 
    GetDIBits(hDC, hBit, 0, bitmap.bmHeight, lpBits, (LPBITMAPINFO)&bmih, DIB_RGB_COLORS); 
 
    ReleaseDC(GetDesktopWindow(), hDC); 
 
    //  
    HANDLE hFile = CreateFile(filename, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    
	if(hFile == INVALID_HANDLE_VALUE)
	{
        delete [] lpBits;
        return FALSE;
	} 
 
    BITMAPFILEHEADER bmfh;  // Ʈ   ü
    bmfh.bfType = 'MB';     // Ʈ  ν
    bmfh.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
    bmfh.bfSize = bmfh.bfOffBits + bmih.biSizeImage;
    bmfh.bfReserved1 = bmfh.bfReserved2 = 0; 
 
    DWORD dwWritten;
    WriteFile(hFile, &bmfh, sizeof(BITMAPFILEHEADER), &dwWritten, NULL);    // Ʈ 
    WriteFile(hFile, &bmih, sizeof(BITMAPINFOHEADER), &dwWritten, NULL);    // Ʈ 
    WriteFile(hFile, lpBits, bmih.biSizeImage, &dwWritten, NULL);           // Ʈʵ 
    CloseHandle(hFile);
 
    delete [] lpBits;

	EmptyClipboard();
	CloseClipboard();

	return TRUE;
}

void CaptureScreen(LPDIRECT3DDEVICE9 pDevice, D3DDISPLAYMODE mode, char* szFileName)
{
	HRESULT hr;

	// ĸó ȭ Ű  Surface Ѵ.
	IDirect3DSurface9* surf;
	if(FAILED(hr = pDevice->CreateOffscreenPlainSurface(mode.Width, mode.Height, D3DFMT_A8R8G8B8, D3DPOOL_SYSTEMMEM, &surf, NULL)))
	{
		return;
	}

	// GetFrontBufferData()Լ     Surface ´.
	if(FAILED(hr = pDevice->GetFrontBufferData(0, surf)))
	{
		surf->Release();
		return;
	}

	// Surface   BMP ȯѴ.
	hr = D3DXSaveSurfaceToFile(_T("GetFrontBufferData.png"), D3DXIFF_PNG, surf, NULL, NULL);
	surf->Release();

	return;
}

void CaptureScreen2(LPDIRECT3DDEVICE9 pDevice, D3DDISPLAYMODE mode, char* szFileName)
{
	HRESULT hr;	

	/*if(FAILED(hr=pDevice->CreateOffscreenPlainSurface( mode.Width, mode.Height, D3DFMT_A8R8G8B8, D3DPOOL_SYSTEMMEM ,&BackSurfaceBuffer, NULL )))
		return;*/

	IDirect3DSurface9* surf; 
	if(FAILED(hr = pDevice->GetBackBuffer( 0, 0, D3DBACKBUFFER_TYPE_MONO, &surf ))){
		surf->Release(); 
		return;
	} 

	hr=D3DXSaveSurfaceToFile(_T("GetBackBuffer.png"), D3DXIFF_PNG, surf, NULL, NULL );
	surf->Release(); 

	return;

}

void CaptureScreen(LPDIRECT3DDEVICE9 pDevice, D3DDISPLAYMODE mode, HWND hWnd, char* szFileName)
{
   if (!pDevice || !szFileName)
       return;

   DWORD tickStart = GetTickCount();
   
   // There is 2 Methods 
   // 1. Capture Front Buffer
   // 2. Capture Back Buffer (Faster)
   bool isBackBuffer = true;
   
   RECT rectWindow = {0};
   RECT rectDesktop = {0};
	//HWND hwnd = GetWindowHandle(m_dwPid);
   GetClientRect(hWnd, &rectWindow);
   GetClientRect(GetDesktopWindow(), &rectDesktop);

   IDirect3DSurface9* pSurface = NULL;
   HRESULT hResult = S_OK;

   if (isBackBuffer)
   {
       hResult = pDevice->GetBackBuffer(0, 0, D3DBACKBUFFER_TYPE_MONO, &pSurface);
   }
   else
   {
       /*
       For windowed mode, the size of the destination surface 
       should be the size of the desktop. For full-screen mode, 
       the size of the destination surface should be the screen size. 
       */

       bool isFullScreen = true; 
       int nWidth    = isFullScreen ? rectWindow.right - rectWindow.left 
                   : rectDesktop.right - rectDesktop.left;
       int nHeight    = isFullScreen ? rectWindow.bottom - rectWindow.top 
                   : rectDesktop.bottom - rectDesktop.top;

      hResult = pDevice->CreateOffscreenPlainSurface(nWidth, nHeight, D3DFMT_A8R8G8B8, D3DPOOL_SCRATCH, &pSurface, NULL);
       hResult = pDevice->GetFrontBufferData(0, pSurface);
   }

   if (pSurface)
   {
       hResult = D3DXSaveSurfaceToFile(_T("hwnd_GetBackBuffer.png"), D3DXIFF_PNG, pSurface, NULL, &rectWindow);
       pSurface->Release();  
   }
// 
//    tickDiff = GetTickCount() - tickStart;
}

void CaptureScreen2(LPDIRECT3DDEVICE9 pDevice, D3DDISPLAYMODE mode, HWND hWnd, char* szFileName)
{
   if (!pDevice || !szFileName)
       return;

   DWORD tickStart = GetTickCount();
   
   // There is 2 Methods 
   // 1. Capture Front Buffer
   // 2. Capture Back Buffer (Faster)
   bool isBackBuffer = false;
   
   RECT rectWindow = {0};
   RECT rectDesktop = {0};
	//HWND hwnd = GetWindowHandle(m_dwPid);
   GetClientRect(GetDesktopWindow(), &rectWindow);
   GetClientRect(GetDesktopWindow(), &rectDesktop);

   IDirect3DSurface9* pSurface = NULL;
   HRESULT hResult = S_OK;

   if (isBackBuffer)
   {
       hResult = pDevice->GetFrontBufferData(0, pSurface);
   }
   else
   {
       /*
       For windowed mode, the size of the destination surface 
       should be the size of the desktop. For full-screen mode, 
       the size of the destination surface should be the screen size. 
       */

       bool isFullScreen = false; 
       int nWidth    = isFullScreen ? rectWindow.right - rectWindow.left 
                   : rectDesktop.right - rectDesktop.left;
       int nHeight    = isFullScreen ? rectWindow.bottom - rectWindow.top 
                   : rectDesktop.bottom - rectDesktop.top;

      hResult = pDevice->CreateOffscreenPlainSurface(nWidth, nHeight, D3DFMT_A8R8G8B8, D3DPOOL_SCRATCH, &pSurface, NULL);
       hResult = pDevice->GetFrontBufferData(0, pSurface);
   }

   if (pSurface)
   {
       hResult = D3DXSaveSurfaceToFile(_T("hwnd_GetFrontBufferData.png"), D3DXIFF_PNG, pSurface, NULL, &rectWindow);
       pSurface->Release();  
   }
// 
//    tickDiff = GetTickCount() - tickStart;
}